diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
new file mode 100644
index 000000000..c1f6d643c
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilder.java
@@ -0,0 +1,231 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import com.b100.utils.FileUtils;
+import com.google.gson.Gson;
+import com.google.gson.GsonBuilder;
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.TypeAdapter;
+import com.google.gson.reflect.TypeToken;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.adapter.ItemStackJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeSymbolJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.WeightedRandomBagJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.WeightedRandomLootObjectJsonAdapter;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.File;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+
+public final class RecipeBuilder {
+
+    /**
+     * @param modID modId for namespace (or 'minecraft' for vanilla namespace)
+     * @return Returns existing recipeNamespace if it already exists, or creates one and returns it if it does not exist.
+     */
+    @NotNull
+    public static RecipeNamespace getRecipeNamespace(String modID){
+        if (Registries.RECIPES.getItem(modID) != null){
+            return Registries.RECIPES.getItem(modID);
+        }
+        RecipeNamespace modSpace = new RecipeNamespace();
+        Registries.RECIPES.register(modID, modSpace);
+        return Objects.requireNonNull(modSpace);
+    }
+
+    /**
+     * @param modID modId for namespace (or 'minecraft' for vanilla namespace)
+     * @param key recipeGroup key
+     * @param symbol {@link RecipeSymbol} which represents the workstation
+     * @return {@link RecipeGroup} Returns existing RecipeGroup if it already exists, or creates one and returns it if it does not exist.
+     */
+    @NotNull
+    public static RecipeGroup<?> getRecipeGroup(String modID, String key, RecipeSymbol symbol){
+        return getRecipeGroup(getRecipeNamespace(modID), key, symbol);
+    }
+    /**
+     * @param namespace {@link RecipeNamespace} which contains the {@link RecipeGroup}
+     * @param key recipeGroup key
+     * @param symbol {@link RecipeSymbol} which represents the workstation
+     * @return {@link RecipeGroup} Returns existing RecipeGroup if it already exists, or creates one and returns it if it does not exist.
+     */
+    @NotNull
+    public static RecipeGroup<?> getRecipeGroup(RecipeNamespace namespace, String key, RecipeSymbol symbol){
+        if (namespace.getItem(key) != null){
+            return namespace.getItem(key);
+        }
+        RecipeGroup<?> group = new RecipeGroup<>(symbol);
+        namespace.register(key, group);
+        return Objects.requireNonNull(group);
+    }
+
+    /**
+     * Gets or creates a specified ItemGroup. <br></br>
+     *
+     * Example code:
+     * <pre>{@code
+     *     RecipeBuilder.getItemGroup("minecraft", "logs")
+     * }</pre>
+     *
+     * @param modID Mod that owns the ItemGroup (or 'minecraft' for vanilla groups)
+     * @param key Group key
+     * @return Returns the existing ItemGroup if it exists, or create one and return that if it doesn't yet exist.
+     */
+    @NotNull
+    public static List<ItemStack> getItemGroup(String modID, String key){
+        List<ItemStack> group = Registries.ITEM_GROUPS.getItem(String.format("%s:%s", modID, key));
+        if (group == null){
+            group = new ArrayList<>();
+            Registries.ITEM_GROUPS.register(String.format("%s:%s", modID, key), group);
+        }
+        return group;
+    }
+
+    /**
+     * Adds specified items to an ItemGroup. If the group does not exist before the method is called then it will be created. <br></br>
+     *
+     * Example code:
+     * <pre>{@code
+     *     RecipeBuilder.addItemsToGroup("minecraft", "cobblestones",
+     *          Block.cobbleStone,
+     *          Block.cobbleBasalt,
+     *          Block.cobbleLimestone,
+     *          Block.cobbleGranite,
+     *          Block.cobblePermafrost)
+     * }</pre>
+     *
+     * @param modID Mod that owns the ItemGroup (or 'minecraft' for vanilla groups)
+     * @param key Group key
+     * @param items List of only {@link IItemConvertible} (which includes Blocks/Items) and {@link ItemStack}
+     */
+    @SuppressWarnings("unused")
+    public static void addItemsToGroup(String modID, String key, Object ... items ){
+        List<ItemStack> group = getItemGroup(modID, key);
+        for (Object o : items){
+            if (o instanceof IItemConvertible){
+                group.add(((IItemConvertible) o).getDefaultStack());
+                continue;
+            }
+            if (o instanceof ItemStack){
+                group.add((ItemStack) o);
+                continue;
+            }
+            throw new IllegalArgumentException(String.format("Object '%s' has invalid class '%s'! Only classes that extend 'IItemConvertible' or 'ItemStack' are allowed!", o.toString(), o.getClass().getSimpleName()));
+        }
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderShaped} <br>
+     * Used for creating new shaped workbench recipes.
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderShaped Shaped(String modID){
+        return new RecipeBuilderShaped(modID);
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderShaped} with its shape set <br>
+     * Used for creating new shaped workbench recipes.
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderShaped Shaped(String modID, String... shape){
+        return new RecipeBuilderShaped(modID, shape);
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderShapeless} <br>
+     * Used for creating new shapeless workbench recipes
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderShapeless Shapeless(String modID){
+        return new RecipeBuilderShapeless(modID);
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderFurnace} <br>
+     * Used for creating new furnace recipes.
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderFurnace Furnace(String modID){
+        return new RecipeBuilderFurnace(modID);
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderBlastFurnace} <br>
+     * Used for creating new blast furnace recipes.
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderBlastFurnace BlastFurnace(String modID){
+        return new RecipeBuilderBlastFurnace(modID);
+    }
+
+    /**
+     * Returns a new {@link RecipeBuilderTrommel} <br>
+     * Used for creating new trommel recipes.
+     */
+    @SuppressWarnings("unused")
+    public static RecipeBuilderTrommel Trommel(String modID){
+        return new RecipeBuilderTrommel(modID);
+    }
+
+    public static boolean isExporting = false;
+
+    /**
+     * Serializes all loaded recipes to json and dumps the output to ".minecraft-bta/recipeDump/recipes.json"
+     */
+    @SuppressWarnings("unchecked")
+    public static void exportRecipes(File output, RecipeGroup<? extends RecipeEntryBase<?, ?, ?>> recipeGroup){
+        isExporting = true;
+        List<? extends RecipeEntryBase<?, ?, ?>> recipesRaw = recipeGroup.getAllRecipes();
+        List<RecipeEntryBase<?, ?, ?>> recipes = new ArrayList<>();
+        GsonBuilder builder = new GsonBuilder();
+        builder.setPrettyPrinting();
+        ArrayList<RecipeJsonAdapter<?>> usedAdapters = new ArrayList<>();
+        for (RecipeEntryBase<?, ?, ?> recipe: recipesRaw) {
+            if (recipe instanceof HasJsonAdapter) {
+                recipes.add(recipe);
+
+                HasJsonAdapter hasJsonAdapter = (HasJsonAdapter) recipe;
+                RecipeJsonAdapter<?> recipeJsonAdapter = hasJsonAdapter.getAdapter();
+                if (usedAdapters.contains(recipeJsonAdapter)) continue;
+                builder.registerTypeAdapter(recipe.getClass(), recipeJsonAdapter);
+                usedAdapters.add(recipeJsonAdapter);
+            }
+        }
+        builder.registerTypeAdapter(ItemStack.class, new ItemStackJsonAdapter());
+        builder.registerTypeAdapter(RecipeSymbol.class, new RecipeSymbolJsonAdapter());
+        builder.registerTypeAdapter(new TypeToken<WeightedRandomBag<WeightedRandomLootObject>>(){}.getType(), new WeightedRandomBagJsonAdapter());
+        builder.registerTypeAdapter(WeightedRandomLootObject.class, new WeightedRandomLootObjectJsonAdapter());
+        Gson gson = builder.create();
+        JsonArray jsonArray = new JsonArray();
+        for (RecipeEntryBase<?, ?, ?> recipeEntryBase : recipes) {
+            TypeAdapter<RecipeEntryBase<?, ?, ?>> typeAdapter = (TypeAdapter<RecipeEntryBase<?, ?, ?>>) gson.getAdapter(recipeEntryBase.getClass());
+            JsonElement json = typeAdapter.toJsonTree(recipeEntryBase);
+            jsonArray.add(json);
+        }
+        if (output.exists()) {
+            output.delete();
+        }
+        File file = FileUtils.createNewFile(output);
+        try (FileWriter fileWriter = new FileWriter(file)){
+            gson.toJson(jsonArray, fileWriter);
+        } catch (IOException iOException) {
+            throw new RuntimeException(iOException);
+        }
+        isExporting = false;
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBase.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBase.java
new file mode 100644
index 000000000..af11697fd
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBase.java
@@ -0,0 +1,33 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import net.minecraft.core.item.ItemStack;
+
+import java.util.Objects;
+
+public abstract class RecipeBuilderBase implements Cloneable {
+    protected String modID;
+    public RecipeBuilderBase(String modID){
+        this.modID = Objects.requireNonNull(modID, "ModID must not be null!");
+    }
+    @SuppressWarnings({"unchecked", "unused"})
+    public <T> T clone(T object){
+        return (T) clone();
+    }
+    @Override
+    public RecipeBuilderBase clone() {
+        try {
+            // none of the fields are mutated so this should be fine
+            return (RecipeBuilderBase) super.clone();
+        } catch (CloneNotSupportedException e) {
+            throw new AssertionError();
+        }
+    }
+
+    /**
+     * Creates a new recipe from the provided builder arguments.
+     * @param recipeID Recipe identifier to assign to the created recipe
+     * @param outputStack Result of crafting the specified recipe
+     */
+    @SuppressWarnings({"unused"})
+    protected abstract void create( String recipeID, ItemStack outputStack);
+}
diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBlastFurnace.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBlastFurnace.java
new file mode 100644
index 000000000..1c2682c01
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderBlastFurnace.java
@@ -0,0 +1,25 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
+import net.minecraft.core.item.ItemStack;
+
+public class RecipeBuilderBlastFurnace extends RecipeBuilderFurnace{
+    /**
+     * Used for creating new blast furnace recipes.
+     * @param modID Namespace to create recipe under
+     */
+    public RecipeBuilderBlastFurnace(String modID) {
+        super(modID);
+    }
+    @Override
+    @SuppressWarnings({"unchecked", "unused"})
+    public void create(String recipeID, ItemStack outputStack) {
+        RecipeGroup< RecipeEntryBlastFurnace> group = ((RecipeGroup< RecipeEntryBlastFurnace>) RecipeBuilder.getRecipeGroup(modID, "blast_furnace", new RecipeSymbol(Blocks.FURNACE_BLAST_ACTIVE.getDefaultStack())));
+        if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
+        group.register(recipeID, new RecipeEntryBlastFurnace(input, outputStack));
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderFurnace.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderFurnace.java
new file mode 100644
index 000000000..7082f6145
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderFurnace.java
@@ -0,0 +1,83 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.Objects;
+
+public class RecipeBuilderFurnace extends RecipeBuilderBase{
+    protected RecipeSymbol input;
+    /**
+     * Used for creating new furnace recipes.
+     * @param modID Namespace to create recipe under
+     */
+    public RecipeBuilderFurnace(String modID) {
+        super(modID);
+    }
+
+    /**
+     * Furnace recipes can only have one input
+     * @param input Input item
+     * @return Copy of {@link RecipeBuilderFurnace}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderFurnace setInput(IItemConvertible input){
+        return setInput(input, 0);
+    }
+
+    /**
+     * Furnace recipes can only have one input
+     * @param input Input item
+     * @param meta Item's required metadata
+     * @return Copy of {@link RecipeBuilderFurnace}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderFurnace setInput(IItemConvertible input, int meta){
+        return setInput(new ItemStack(input, 1, meta));
+    }
+
+    /**
+     * Furnace recipes can only have one input
+     * @param input Input {@link ItemStack}
+     * @return Copy of {@link RecipeBuilderFurnace}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderFurnace setInput(ItemStack input){
+        return setInput(new RecipeSymbol(input));
+    }
+
+    /**
+     * Furnace recipes can only have one input
+     * @param itemGroup Input item group
+     * @return Copy of {@link RecipeBuilderFurnace}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderFurnace setInput(String itemGroup){
+        return setInput(new RecipeSymbol(itemGroup));
+    }
+
+    /**
+     * Furnace recipes can only have one input
+     * @param input {@link RecipeSymbol} Input symbol
+     * @return Copy of {@link RecipeBuilderFurnace}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderFurnace setInput(RecipeSymbol input){
+        RecipeBuilderFurnace builder = this.clone(this);
+        builder.input = Objects.requireNonNull(input, "Input symbol must not be null!");
+        return builder;
+    }
+
+    @Override
+    @SuppressWarnings({"unchecked"})
+    public void create(String recipeID, ItemStack outputStack) {
+        Objects.requireNonNull(input, "Input symbol must not be null!");
+        RecipeGroup<RecipeEntryFurnace> group = ((RecipeGroup<RecipeEntryFurnace>) RecipeBuilder.getRecipeGroup(modID, "furnace", new RecipeSymbol(Blocks.FURNACE_STONE_ACTIVE.getDefaultStack())));
+        if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
+        group.register(recipeID, new RecipeEntryFurnace(input, outputStack));
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
new file mode 100644
index 000000000..9765b4c1b
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShaped.java
@@ -0,0 +1,221 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.Arrays;
+import java.util.HashMap;
+
+import static net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped.DEFAULT_ALLOW_MIRROR;
+import static net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped.DEFAULT_CONSUME_CONTAINER;
+
+public class RecipeBuilderShaped extends RecipeBuilderBase{
+    protected String[] shape;
+    protected int width;
+    protected int height;
+    protected boolean consumeContainer = DEFAULT_CONSUME_CONTAINER;
+    protected boolean allowMirrored = DEFAULT_ALLOW_MIRROR;
+    protected final HashMap<Character, RecipeSymbol> symbolShapedMap = new HashMap<>();
+    /**
+     * Used for creating new shaped workbench recipes.
+     * @param modID Namespace to create recipe under
+     */
+    public RecipeBuilderShaped(String modID){
+        super(modID);
+    }
+    /**
+     * Used for creating new shaped workbench recipes.
+     * @param modID Namespace to create recipe under
+     * @param shape Recipe shape in symbol representation
+     */
+    public RecipeBuilderShaped(String modID, String... shape) {
+        super(modID);
+        setShapeLocal(shape);
+    }
+
+    /**
+     * Sets the shape of the recipe
+     * Example code:
+     * <pre>{@code
+     *     RecipeBuilderShaped("minecraft")
+     *       .setShape(
+     *          "PPP",
+     *          "P P",
+     *          "PPP")
+     *       .addInput('P', Block.planksOak)
+     *       .create("chest_planks_oak", Block.chestPlanksOak.getDefaultStack());
+     * }</pre>
+     * @param shapeTemplate Recipe shape in symbol representation
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped setShape(String... shapeTemplate){
+        RecipeBuilderShaped builder = this.clone(this);
+        builder.setShapeLocal(shapeTemplate);
+        return builder;
+    }
+    protected void setShapeLocal(String... shape){
+        if (shape == null){
+            throw new IllegalArgumentException("Shape Template cannot be set to null!");
+        }
+        if (shape.length == 0){
+            throw new IllegalArgumentException("Shape Template cannot have a size of 0!");
+        }
+        if (shape.length > 3){
+            throw new IllegalArgumentException("Shape Template height cannot exceed 3!\n" + Arrays.toString(shape));
+        }
+        if (shape[0].length() > 3){
+            throw new IllegalArgumentException("Shape Template width cannot exceed 3!\n" + Arrays.toString(shape));
+        }
+        this.height = shape.length;
+        this.width = shape[0].length();
+
+        // Gets the max width
+        for (int y = 0; y < this.height; y++) {
+            this.width = Math.max(this.width, shape[y].length());
+        }
+
+        // Ensures that the recipe shape is always square
+        String[] internalShape = new String[height];
+        for (int y = 0; y < internalShape.length; y++) {
+            StringBuilder builder = new StringBuilder();
+            String row = shape[y];
+            for (int x = 0; x < width; x++) {
+                if (x >= row.length()){
+                    builder.append(" ");
+                } else {
+                    builder.append(row.charAt(x));
+                }
+            }
+            internalShape[y] = builder.toString();
+        }
+
+        this.shape = internalShape;
+    }
+
+    /**
+     * Specifies whether the recipe should consume container items.
+     * <pre>{@code
+     *     RecipeBuilderShaped("minecraft")
+     *       .setShape(
+     *          "BBB",
+     *          "SES",
+     *          "WWW")
+     *       .addInput('B', Item.bucketMilk)
+     *       .addInput('S', Item.dustSugar)
+     *       .addInput('E', Item.eggChicken)
+     *       .addInput('W', Item.wheat)
+     *       .setConsumeContainer(false) // Recipe will return empty buckets when crafted
+     *       .create("cake", Item.cake.getDefaultStack());
+     * }</pre>
+     * @param consumeContainer Should consume ContainerItem
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped setConsumeContainer(boolean consumeContainer){
+        RecipeBuilderShaped builder = this.clone(this);
+        builder.consumeContainer = consumeContainer;
+        return builder;
+    }
+
+    public RecipeBuilderShaped setAllowMirrored(boolean allowMirrored) {
+        RecipeBuilderShaped builder = this.clone(this);
+        builder.allowMirrored = allowMirrored;
+        return builder;
+    }
+
+    /**
+     * Assigns an item to an item symbol defined in the shape (see {@link #setShape(String...)})
+     * @param templateSymbol Item symbol character
+     * @param stack Stack to assign
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped addInput(char templateSymbol, IItemConvertible stack){
+        return addInput(templateSymbol, stack, 0);
+    }
+
+    /**
+     * Assigns an item to an item symbol defined in the shape (see {@link #setShape(String...)})
+     * @param templateSymbol Item symbol character
+     * @param stack Stack to assign
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped addInput(char templateSymbol, IItemConvertible stack, int meta){
+        ItemStack _stack = stack.getDefaultStack();
+        _stack.setMetadata(meta);
+        return addInput(templateSymbol, _stack);
+    }
+
+    /**
+     * Assigns an item to an item symbol defined in the shape (see {@link #setShape(String...)})
+     * @param templateSymbol Item symbol character
+     * @param stack Stack to assign
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped addInput(char templateSymbol, ItemStack stack){
+        return addInput(templateSymbol, new RecipeSymbol(stack));
+    }
+
+    /**
+     * Assigns an itemGroup to an item symbol defined in the shape (see {@link #setShape(String...)})
+     * @param templateSymbol Item symbol character
+     * @param itemGroup ItemGroup key to assign
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped addInput(char templateSymbol, String itemGroup) {
+        return addInput(templateSymbol, new RecipeSymbol(itemGroup));
+    }
+
+    /**
+     * Assigns an item to an item symbol defined in the shape (see {@link #setShape(String...)})
+     * @param templateSymbol Item symbol character
+     * @param symbol {@link RecipeSymbol} to assign
+     * @return Copy of {@link RecipeBuilderShaped}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShaped addInput(char templateSymbol, RecipeSymbol symbol){
+        if (templateSymbol == ' ') throw new IllegalArgumentException("Cannot assign item to protected symbol ' ' pick a different symbol for your recipe input");
+        RecipeBuilderShaped builder = this.clone(this);
+        symbolShapedMap.put(templateSymbol, symbol);
+        return builder;
+    }
+
+    @SuppressWarnings({"unchecked", "unused"})
+    public void create(String recipeID, ItemStack outputStack) {
+        if (shape == null) throw new RuntimeException("Shaped recipe: " + recipeID + " attempted to build without a assigned shape!!");
+        RecipeSymbol[] recipe = new RecipeSymbol[height * width];
+        for (int x = 0; x < width; x++) {
+            for (int y = 0; y < height; y++) {
+                Character cha = null;
+                if (shape[y].length() > x) {
+                    cha = shape[y].charAt(x);
+                }
+                RecipeSymbol tempplate = symbolShapedMap.get(cha);
+                if (tempplate == null){
+                    recipe[x + y * width] = null;
+                } else {
+                    if(tempplate.getItemGroup() == null){
+                        RecipeSymbol s =  new RecipeSymbol(cha == null ? ' ' : cha, tempplate.getStack());
+                        recipe[x + y * width] = s;
+                    } else {
+                        recipe[x + y * width] = new RecipeSymbol(cha == null ? ' ' : cha, tempplate.getStack(), tempplate.getItemGroup());
+                    }
+
+                }
+
+            }
+        }
+        RecipeGroup<RecipeEntryCrafting<?, ?>> group = ((RecipeGroup<RecipeEntryCrafting<?, ?>>) RecipeBuilder.getRecipeGroup(modID, "workbench", new RecipeSymbol(Blocks.WORKBENCH.getDefaultStack())));
+        if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
+        group.register(recipeID, new RecipeEntryCraftingShaped(width, height, recipe, outputStack, consumeContainer, allowMirrored));
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
new file mode 100644
index 000000000..c9c644c2f
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/recipeBuilders/RecipeBuilderShapeless.java
@@ -0,0 +1,80 @@
+package net.minecraft.datagen.recipeBuilders;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class RecipeBuilderShapeless extends RecipeBuilderBase{
+    private final List<RecipeSymbol> symbolShapelessList = new ArrayList<>();
+    /**
+     * Used for creating new shapeless workbench recipes.
+     * @param modID Namespace to create recipe under
+     */
+    public RecipeBuilderShapeless(String modID) {
+        super(modID);
+    }
+
+    /**
+     * @param stack Item to add to recipe's item list
+     * @return Copy of {@link RecipeBuilderShapeless}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShapeless addInput(IItemConvertible stack){
+        return addInput(stack, 0);
+    }
+
+    /**
+     * @param stack Item to add to recipe's item list
+     * @param meta Required meta of the item
+     * @return Copy of {@link RecipeBuilderShapeless}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShapeless addInput(IItemConvertible stack, int meta){
+        ItemStack _stack = stack.getDefaultStack();
+        _stack.setMetadata(meta);
+        return addInput(_stack);
+    }
+
+    /**
+     * @param itemGroup ItemGroup to add to recipe's item list
+     * @return Copy of {@link RecipeBuilderShapeless}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShapeless addInput(String itemGroup){
+        return addInput(new RecipeSymbol(itemGroup));
+    }
+
+    /**
+     * @param stack Item to add to recipe's item list
+     * @return Copy of {@link RecipeBuilderShapeless}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShapeless addInput(ItemStack stack){
+        return addInput(new RecipeSymbol(stack));
+    }
+
+    /**
+     * @param symbol {@link RecipeSymbol} to add to recipe's item list
+     * @return Copy of {@link RecipeBuilderShapeless}
+     */
+    @SuppressWarnings({"unused"})
+    public RecipeBuilderShapeless addInput(RecipeSymbol symbol){
+        RecipeBuilderShapeless builder = this.clone(this);
+        symbolShapelessList.add(symbol);
+        return builder;
+    }
+    @Override
+    @SuppressWarnings({"unused", "unchecked"})
+    public void create(String recipeID, ItemStack outputStack) {
+        RecipeGroup<RecipeEntryCrafting<?, ?>> group = ((RecipeGroup<RecipeEntryCrafting<?, ?>>) RecipeBuilder.getRecipeGroup(modID, "workbench", new RecipeSymbol(Blocks.WORKBENCH.getDefaultStack())));
+        if (group.getItem(recipeID) != null) throw new IllegalArgumentException("RecipeID '" + recipeID + "' already exists!");
+        group.register(recipeID, new RecipeEntryCraftingShapeless(symbolShapelessList, outputStack));
+    }
+}
